﻿using System;
using System.Data;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class MultiRowDisConn : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!IsPostBack)
        {
            # region ****** 「多筆編輯 + 離線編輯 + 多人並行存取衝突偵測 + 批次寫入資料庫」的功能區塊 ******

            // 取得資料表中的 Schema(包括各個欄位名稱) 和資料內容
            DataTable dtOriginal = new DataTable();
            com.RPTI.DAL.MultiRowDisConn_DAL da = new com.RPTI.DAL.MultiRowDisConn_DAL();
            dtOriginal = da.SelectDataSetBindGridView();

            GridView1.DataSource = dtOriginal;
            GridView1.DataBind();

            // 別支程式在套用時，以下三個 ViewState 的名稱請勿修改
            ViewState["vs_dt_GridView1"] = dtOriginal;
            ViewState["vs_dt_AfterInserted"] = dtOriginal;  // 暫存一或多次按下「新增」按鈕後的所有資料列，包括資料表的原始資料列 + 使用者新增的一或多筆資料列 (按下「新增」按鈕時會引用)
            
            // 資料庫中資料表的原始筆數 (亦為本程式要做「修改」的筆數)
            ViewState["vs_GridView1_OriginalRowCount"] = GridView1.Rows.Count;

            if (dtOriginal != null)
            {
                dtOriginal.Dispose();
            }

            # endregion ****** 「多筆編輯 + 離線編輯 + 多人並行存取衝突偵測 + 批次寫入資料庫」的功能區塊 ******
        }

        // GridView1 至少要有一筆資料 (不包括 FooterRow)，才能按「存檔」按鈕，去實際存入資料庫
        if (GridView1.Rows.Count == 0)
        {
            btnSave.Enabled = false;
        }
        else
        {
            btnSave.Enabled = true;
        }
    } // end of Page_Load()


    // 新增 (離線新增一筆到 DataTable 裡)
    protected void btnAdd_Click(object sender, EventArgs e)
    {
        // 若資料表有至少一筆資料 (不包括 FooterRow)
        if (GridView1.Rows.Count > 0)
        {
            // 取得「新增列」FooterRow 上的四個 TextBox，及使用者對它們的輸入值
            TextBox tb_footer_float1 = GridView1.FooterRow.FindControl("tb_footer_float1") as TextBox;  // as 為一種轉型語法，但失敗時會回傳 null，不會引發 Exception
            TextBox tb_footer_date1 = GridView1.FooterRow.FindControl("tb_footer_date1") as TextBox;
            TextBox tb_footer_varchar1 = GridView1.FooterRow.FindControl("tb_footer_varchar1") as TextBox;
            TextBox tb_footer_varchar2 = GridView1.FooterRow.FindControl("tb_footer_varchar2") as TextBox;

            DataTable dtAfterInserted = new DataTable();    // 暫存一或多次按下「新增」按鈕後的所有資料列，包括資料表的原始資料列 + 使用者新增的一或多筆資料列
            DataRow drAfterInserted;

            dtAfterInserted = ((DataTable)ViewState["vs_dt_AfterInserted"]).Copy();     // 拷貝 DataTable 中的結構和資料
            drAfterInserted = dtAfterInserted.NewRow();
            
            //若要在 DataTable 裡，手動新增資料表中不存在的欄位，可用以下語法
            //drAfterInserted["ii"] = "新增";
            //drAfterInserted["id"] = GridView1.DataKeys[i].Value;

            // 此資料表欄位為 float 型別，若使用者未輸入，則給預設值 0 (當作驗證功能，否則程式會當掉)
            if (tb_footer_float1.Text.Trim().Length == 0)
                drAfterInserted["float1"] = 0;
            else
                drAfterInserted["float1"] = tb_footer_float1.Text.Trim();

            // 此資料表欄位為 datetime 型別，若使用者未輸入，則給預設值今天的日期 (當作驗證功能，否則程式會當掉)
            if (tb_footer_date1.Text.Trim().Length == 0)
                drAfterInserted["date1"] = DateTime.Now.ToString();
            else
                drAfterInserted["date1"] = tb_footer_date1.Text.Trim();
                        
            drAfterInserted["varchar1"] = tb_footer_varchar1.Text.Trim();
            drAfterInserted["varchar2"] = tb_footer_varchar2.Text.Trim();

            dtAfterInserted.Rows.Add(drAfterInserted);

            ViewState["vs_dt_AfterInserted"] = dtAfterInserted;     // 此時 ViewState、DataTable 中，為資料庫中的原始多筆資料列 + 剛新增的那一筆
            

            #region ****** 暫存使用者的輸入值在 DataTable 中，以便按下「新增」按鈕、重新繫結 GridView1 之後，仍能將使用者的輸入值手動回填 GridView1 ******

            DataTable dtInsertInput = new DataTable();  // 暫存使用者在 GridView1 每一列的所有 TextBox、CheckBox 的輸入值，但不包括「新增列」FooterRow

            dtInsertInput = ((DataTable)ViewState["vs_dt_AfterInserted"]).Clone();     // 拷貝 DataTable 中的結構，不拷貝資料
            DataColumn dcInsertInput;
            DataRow drInsertInput;

            if (dtInsertInput.Columns["chk"] == null)
            {
                dcInsertInput = new DataColumn();
                dcInsertInput.DataType = Type.GetType("System.String");
                dcInsertInput.ColumnName = "chk";
                dtInsertInput.Columns.Add(dcInsertInput);
            }

            // 將 GridView1 上每一列 (不包括「新增列」FooterRow)、每一個控制項的值，包括使用者的輸入值，都暫存至 DataTable 中
            for (int i = 0; i < GridView1.Rows.Count; i++)
            {
                drInsertInput = dtInsertInput.NewRow();
                                
                drInsertInput["chk"] = ((CheckBox)GridView1.Rows[i].FindControl("cbSelect")).Checked;   // True 或 False

                // 此資料表欄位為 float 型別，若使用者未輸入，則給預設值 0 (當作驗證功能，否則程式會當掉)
                if (((TextBox)GridView1.Rows[i].FindControl("tb_float1")).Text.Trim().Length == 0)
                    drInsertInput["float1"] = 0;
                else
                    drInsertInput["float1"] = ((TextBox)GridView1.Rows[i].FindControl("tb_float1")).Text.Trim();

                // 此資料表欄位為 datetime 型別，若使用者未輸入，則給預設值今天的日期 (當作驗證功能，否則程式會當掉)
                if (((TextBox)GridView1.Rows[i].FindControl("tb_date1")).Text.Trim().Length == 0)
                    drInsertInput["date1"] = DateTime.Now.ToString();
                else
                    drInsertInput["date1"] = ((TextBox)GridView1.Rows[i].FindControl("tb_date1")).Text.Trim();

                drInsertInput["varchar1"] = ((TextBox)GridView1.Rows[i].FindControl("tb_varchar1")).Text.Trim();
                drInsertInput["varchar2"] = ((TextBox)GridView1.Rows[i].FindControl("tb_varchar2")).Text.Trim();
                
                dtInsertInput.Rows.Add(drInsertInput);
            }

            // 繫結至純粹給開發人員參考用的 GridView_InsertInput 中
            GridView_InsertInput.DataSource = dtInsertInput;
            GridView_InsertInput.DataBind();

            #endregion ****** 暫存使用者的輸入值在 DataTable 中，以便按下「新增」按鈕、重新繫結 GridView1 之後，仍能將使用者的輸入值手動回填 GridView1 ******


            // 讓剛才 FooterRow 新增至記憶體中的那一筆，即時顯示在 GridView1 中 (重新繫結，但此時會造成使用者在 GridView1 的輸入值遺失)
            GridView1.DataSource = dtAfterInserted;
            GridView1.DataBind();


            #region ****** 將暫存在 DataTable 中的使用者輸入值，在按下「新增」按鈕、重新繫結 GridView1 之後，再手動回填 GridView1 ******

            // 此時因 GridView1 已在最下方新增了一列，因此 dtInsertInput.Rows.Count 會比 GridView1.Rows.Count 少一列
            for (int i = 0; i < dtInsertInput.Rows.Count; i++)
            {
                // 將 DataTable 中暫存的 GridView1 每一列的所有 TextBox、CheckBox 的輸入值，回填回 GridView1 裡每一列的每個控制項中
                if (dtInsertInput.Rows[i]["chk"].ToString() == "True")
                    ((CheckBox)GridView1.Rows[i].FindControl("cbSelect")).Checked = true;
                else if (dtInsertInput.Rows[i]["chk"].ToString() == "False")
                    ((CheckBox)GridView1.Rows[i].FindControl("cbSelect")).Checked = false;
                ((TextBox)GridView1.Rows[i].FindControl("tb_float1")).Text = dtInsertInput.Rows[i]["float1"].ToString();
                // 因暫存在 DataTable 中的 datetime 為長格式日期，因此手動轉成短格式日期
                ((TextBox)GridView1.Rows[i].FindControl("tb_date1")).Text = Convert.ToDateTime(dtInsertInput.Rows[i]["date1"]).ToString("yyyy/MM/dd");
                ((TextBox)GridView1.Rows[i].FindControl("tb_varchar1")).Text = dtInsertInput.Rows[i]["varchar1"].ToString();
                ((TextBox)GridView1.Rows[i].FindControl("tb_varchar2")).Text = dtInsertInput.Rows[i]["varchar2"].ToString();
            }

            #endregion ****** 將暫存在 DataTable 中的使用者輸入值，在按下「新增」按鈕、重新繫結 GridView1 之後，再手動回填 GridView1 ******


            // 釋放 DataTable 資源            
            if (dtAfterInserted != null)
            {
                dtAfterInserted.Dispose();
            }      
            drAfterInserted = null;

            if (dtInsertInput != null)
            {
                dtInsertInput.Dispose();
            }
            dcInsertInput = null;
            drInsertInput = null;  
        }
        else  // 若資料表一筆資料都沒有；或此頁為專做「新增」的頁面，一開始就是空 GridView
        {
            // FooterRow 此時本來不會顯示，但我們用資料表的 Schema 和一個臨時新增的 DataTable，和頁面中 GridView 裡的 EmptyTemplate 裡的一些控制項，
            // 硬湊出一個外觀類似 FooterRow 的輸入 Bar，給使用者新增之用
            DataTable dtEmpty = (DataTable)ViewState["vs_dt_GridView1"];    // 取得資料庫中的 Schema，但沒任何資料
            DataRow drEmpty = dtEmpty.NewRow();
            drEmpty.BeginEdit();

            // 取得 GridView 裡 EmptyTemplate 的資料列和該列的控制項
            TableRow tr = (TableRow)(GridView1.Controls[0].Controls[0]);

            // 此資料表欄位為 float 型別，若使用者未輸入，則給預設值 0 (當作驗證功能，否則程式會當掉)
            if (((TextBox)tr.FindControl("tb_footer_float1")).Text.Trim().Length == 0)
                drEmpty["float1"] = 0;
            else
                drEmpty["float1"] = ((TextBox)tr.FindControl("tb_footer_float1")).Text.Trim();

            // 此資料表欄位為 datetime 型別，若使用者未輸入，則給預設值今天的日期 (當作驗證功能，否則程式會當掉)
            if (((TextBox)tr.FindControl("tb_footer_date1")).Text.Trim().Length == 0)
                drEmpty["date1"] = DateTime.Now.ToString();
            else
                drEmpty["date1"] = ((TextBox)tr.FindControl("tb_footer_date1")).Text.Trim();

            drEmpty["varchar1"] = ((TextBox)tr.FindControl("tb_footer_varchar1")).Text.Trim();
            drEmpty["varchar2"] = ((TextBox)tr.FindControl("tb_footer_varchar2")).Text.Trim();

            drEmpty.EndEdit();
            dtEmpty.Rows.Add(drEmpty);

            GridView1.DataSource = dtEmpty;
            GridView1.DataBind();

            ViewState["vs_dt_AfterInserted"] = dtEmpty;     // 此時 ViewState 中只有一筆資料 (內容為使用者剛輸入的)

            if (dtEmpty != null)
            {
                dtEmpty.Dispose();
            }
            drEmpty = null;
        }

        // GridView1 至少要有一筆資料 (不包括 FooterRow)，才能按「存檔」按鈕，實際去存入資料庫
        if (GridView1.Rows.Count == 0)
        {
            btnSave.Enabled = false;
        }
        else
        {
            btnSave.Enabled = true;
        }

    } // end of btnAdd_Click()


    // 存檔，把所有的「修改、刪除、新增」內容，真正寫入資料庫
    protected void btnSave_Click(object sender, EventArgs e)
    {
        #region ****** 將使用者輸入的值，依「修改、刪除」和「新增」分成上下兩個區塊，各拷貝至一個暫存的 GridView (GridView_Update、GridView_Insert) ******

        DataTable dtUpdate = new DataTable();   // 要傳入 DAL 層的參數一，內容為使用者在 GridView1 的所有「修改、刪除」資料列
        DataTable dtInsert = new DataTable();   // 要傳入 DAL 層的參數二，內容為使用者在 GridView1 的所有「新增」資料列
        DataColumn dcUpdate;
        DataColumn dcInsert;
        DataRow drUpdate;        
        DataRow drInsert;
        int intGridView1_OriginalRowCount = Convert.ToInt32(ViewState["vs_GridView1_OriginalRowCount"]);    // 資料庫中資料表的原始筆數 (亦為本程式要做「修改」的筆數)

        dtUpdate = ((DataTable)ViewState["vs_dt_GridView1"]).Clone();   // 拷貝 DataTable 中的結構 (不包括資料)
        dtInsert = ((DataTable)ViewState["vs_dt_GridView1"]).Clone();   // 拷貝 DataTable 中的結構 (不包括資料)

        // ****** 處理 dtUpdate、GridView_Update ******

        // 將 GridView_Update 不需要的欄位，從 dtUpdate 中移除 (非必要動作。若不加下列這四行，只是會讓 GridView_Update 多出四個用不到的空欄位)
        dtUpdate.Columns.Remove("varchar3");
        dtUpdate.Columns.Remove("varchar4");
        dtUpdate.Columns.Remove("varchar5");

        if (dtUpdate.Columns["chk"] == null)
        {
            dcUpdate = new DataColumn();
            dcUpdate.DataType = Type.GetType("System.String");
            dcUpdate.ColumnName = "chk";
            dtUpdate.Columns.Add(dcUpdate);
        }
        //drUpdate = dtUpdate.NewRow();

        // 若資料庫的資料表有一筆以上的資料，就將使用者在 GridView1 每一列、每一個 TextBox 的輸入值，暫存至 DataTable dtUpdate 中，以當作 DAL 層要寫入資料庫的內容值
        if (intGridView1_OriginalRowCount > 0)
        {
            for (int i = 0; i < intGridView1_OriginalRowCount; i++)
            {
                drUpdate = dtUpdate.NewRow();

                drUpdate["id"] = GridView1.DataKeys[i].Value;   // id 為主鍵，從前端 .aspx 的 GridView 的 DataKeyNames 屬性設定 (若為複合主鍵，就用「,」隔開)

                // 此資料表欄位為 float 型別，若使用者未輸入，則給預設值 0 (當作驗證功能，否則程式會當掉)
                if (((TextBox)GridView1.Rows[i].FindControl("tb_float1")).Text.Trim().Length == 0)
                    drUpdate["float1"] = 0;
                else
                    drUpdate["float1"] = ((TextBox)GridView1.Rows[i].FindControl("tb_float1")).Text.Trim();

                // 此資料表欄位為 datetime 型別，若使用者未輸入，則給預設值今天的日期 (當作驗證功能，否則程式會當掉)
                if (((TextBox)GridView1.Rows[i].FindControl("tb_date1")).Text.Trim().Length == 0)
                    drUpdate["date1"] = DateTime.Now.ToString();
                else
                    drUpdate["date1"] = ((TextBox)GridView1.Rows[i].FindControl("tb_date1")).Text.Trim();

                drUpdate["varchar1"] = ((TextBox)GridView1.Rows[i].FindControl("tb_varchar1")).Text.Trim();
                drUpdate["varchar2"] = ((TextBox)GridView1.Rows[i].FindControl("tb_varchar2")).Text.Trim();
                drUpdate["MODIFY_DT"] = ((HiddenField)GridView1.Rows[i].FindControl("hfMODIFY_DT")).Value;
                drUpdate["chk"] = ((CheckBox)GridView1.Rows[i].FindControl("cbSelect")).Checked;                

                dtUpdate.Rows.Add(drUpdate);

                // 繫結至純粹給開發人員參考用的 GridView_Update 中
                GridView_Update.DataSource = dtUpdate;
                GridView_Update.DataBind();
            }
        }

        // ****** 處理 dtInsert、GridView_Insert ******

        // 將 GridView_Update 不需要的欄位，從 dtInsert 中移除 (非必要動作。若不加下列這四行，只是會讓 GridView_Insert 多出四個用不到的空欄位)
        dtInsert.Columns.Remove("varchar3");
        dtInsert.Columns.Remove("varchar4");
        dtInsert.Columns.Remove("varchar5");
        dtInsert.Columns.Remove("MODIFY_DT");

        if (dtInsert.Columns["chk"] == null)
        {
            dcInsert = new DataColumn();
            dcInsert.DataType = Type.GetType("System.String");
            dcInsert.ColumnName = "chk";
            dtInsert.Columns.Add(dcInsert);
        }

        // 若使用者在 GridView1 中，至少曾經新增一筆資料列，則將使用者新增的一或多筆資料列，暫存至 DataTable dtInsert 中，以當作 DAL 層要寫入資料庫的內容值
        if (GridView1.Rows.Count > 0)
        {
            for (int i = intGridView1_OriginalRowCount; i < GridView1.Rows.Count; i++)
            {
                drInsert = dtInsert.NewRow();

                // 下面這一行為非必要，只是純粹給開發人員作參考之用
                drInsert["id"] = GridView1.DataKeys[i].Value;   // id 為主鍵，從 .aspx 的 GridView 的 DataKeyNames 屬性設定 (若為複合主鍵，就用「,」隔開)

                // 此資料表欄位為 float 型別，若使用者未輸入，則給預設值 0 (當作驗證功能，否則程式會當掉)
                if (((TextBox)GridView1.Rows[i].FindControl("tb_float1")).Text.Trim().Length == 0)
                    drInsert["float1"] = 0;
                else
                    drInsert["float1"] = ((TextBox)GridView1.Rows[i].FindControl("tb_float1")).Text.Trim();

                // 此資料表欄位為 datetime 型別，若使用者未輸入，則給預設值今天的日期 (當作驗證功能，否則程式會當掉)
                if (((TextBox)GridView1.Rows[i].FindControl("tb_date1")).Text.Trim().Length == 0)
                    drInsert["date1"] = DateTime.Now.ToString();
                else
                    drInsert["date1"] = ((TextBox)GridView1.Rows[i].FindControl("tb_date1")).Text.Trim();
                                
                drInsert["varchar1"] = ((TextBox)GridView1.Rows[i].FindControl("tb_varchar1")).Text.Trim();
                drInsert["varchar2"] = ((TextBox)GridView1.Rows[i].FindControl("tb_varchar2")).Text.Trim();
                drInsert["chk"] = ((CheckBox)GridView1.Rows[i].FindControl("cbSelect")).Checked;

                dtInsert.Rows.Add(drInsert);

                // 繫結至純粹給開發人員參考用的 GridView_Insert 中
                GridView_Insert.DataSource = dtInsert;
                GridView_Insert.DataBind();
            }
        }        

        #endregion


        #region ****** 將「修改、刪除」和「新增」上下兩個區塊，暫存在 GridView_Update、GridView_Insert 裡的值，透過 DAL 層實際寫入資料庫 ******

        // DAL 層裡 UpdateGridView 函數的功能:
        // step 1: 修改: 在 GridView1 上半部區塊裡，不論前面是否有勾選，將每一筆資料都存入資料庫 (並做 Concurrent 多人並行存取衝突偵測)
        // step 2: 刪除: 在 GridView1 上半部區塊裡，將前面有勾選的資料列，從資料庫裡刪除 (並做 Concurrent 多人並行存取衝突偵測)
        // step 3: 若前述「修改、刪除」都已成功，就將 GridView1 上半部區塊裡，每筆的 MODIFY_DT 更新成最新的時間
        // step 4: 新增: 在 GridView1 下半部區塊裡，將前面有勾選的資料列，存入資料庫；若沒勾選則不處理

        try
        {
            com.RPTI.DAL.MultiRowDisConn_DAL mrdc = new com.RPTI.DAL.MultiRowDisConn_DAL();
            int intReturn = mrdc.UpdateGridView(dtUpdate, dtInsert);

            if (intReturn > 0)
            {
                string strResourceFileName = "修改成功！";
                Literal litTxtMsg = new Literal();
                litTxtMsg.Text = "<script>alert('" + strResourceFileName + "\\n')</script>";
                Page.Controls.Add(litTxtMsg);


                // 若全部寫入成功，就再重新取得資料庫中最新的資料 (包括 MODIFY_DT)，並重新繫結至 GridView1 中顯示出來；
                // 以下的十三行程式碼，是和 Page_Load() 裡的 !IsPostBack 區塊裡相同的動作。
                DataTable dtUpdateComplete = new DataTable();
                com.RPTI.DAL.MultiRowDisConn_DAL da = new com.RPTI.DAL.MultiRowDisConn_DAL();
                dtUpdateComplete = da.SelectDataSetBindGridView();

                GridView1.DataSource = dtUpdateComplete;
                GridView1.DataBind();

                // 別支程式在套用時，以下三個 ViewState 的名稱請勿修改
                ViewState["vs_dt_GridView1"] = dtUpdateComplete;
                ViewState["vs_dt_AfterInserted"] = dtUpdateComplete;

                // 資料庫中資料表的原始筆數 (亦為本程式要做「修改」的筆數)
                ViewState["vs_GridView1_OriginalRowCount"] = GridView1.Rows.Count;

                if (dtUpdateComplete != null)
                {
                    dtUpdateComplete.Dispose();
                }
            }
            else if (intReturn == 0)
            {
                string strResourceFileName = "修改失敗！\\n系統偵測到在同一時間內，已經有人先修改過本頁中的一或多筆資料。\\n請按「回上一頁」按鈕，再重新進入本頁。";
                Literal litTxtMsg = new Literal();
                litTxtMsg.Text = "<script>alert('" + strResourceFileName + "\\n')</script>";
                Page.Controls.Add(litTxtMsg);
            }
            else
            {
                // 可能進入這個區塊的情況: 若為全空的資料表，一筆資料都還沒有，使用者就按下「存檔」按鈕
                Response.Write("修改失敗，但未發生 Exception");
            }
        }
        catch (Exception ex)
        {
            Response.Write("修改失敗，原因: <br>" + ex.ToString() + "<br>");
        }

        
        // 釋放 DataTable 資源
        if (dtUpdate != null)
        {
            dtUpdate.Dispose();
        }
        if (dtInsert != null)
        {
            dtInsert.Dispose();
        }
        dcUpdate = null;
        dcInsert = null;
        drUpdate = null;
        drInsert = null;

        #endregion ****** 將「修改、刪除」和「新增」上下兩個區塊，暫存在 GridView_Update、GridView_Insert 裡的值，透過 DAL 層實際寫入資料庫 ******

        // GridView1 至少要有一筆資料 (不包括 FooterRow)，才能按「存檔」按鈕，去實際存入資料庫
        if (GridView1.Rows.Count == 0)
        {
            btnSave.Enabled = false;
        }
        else
        {
            btnSave.Enabled = true;
        }

    } // end of btnSave_Click()


    // 取消 (清除使用者在「新增列」FooterRow 的輸入值)
    protected void btnCancel_Click(object sender, EventArgs e)
    {
        if (GridView1.Rows.Count > 0)
        {
            // FooterTemplate
            ((TextBox)GridView1.FooterRow.FindControl("tb_footer_float1")).Text = "";
            ((TextBox)GridView1.FooterRow.FindControl("tb_footer_date1")).Text = "";
            ((TextBox)GridView1.FooterRow.FindControl("tb_footer_varchar1")).Text = "";
            ((TextBox)GridView1.FooterRow.FindControl("tb_footer_varchar2")).Text = "";
        }
        else
        {
            // EmptyDataTemplate
            TableRow tr = (TableRow)(GridView1.Controls[0].Controls[0]);
            ((TextBox)tr.FindControl("tb_footer_float1")).Text = "";
            ((TextBox)tr.FindControl("tb_footer_date1")).Text = "";
            ((TextBox)tr.FindControl("tb_footer_varchar1")).Text = "";
            ((TextBox)tr.FindControl("tb_footer_varchar2")).Text = "";
        }
    }


} // end of class
